<?php
/**
*
* @package class_Zipper
* @author Vincent DUFFAUT pour Allowin
* @access public
* @version 1.0
* @copyright Allowin (http://www.allowin.com)
* @license   http://opensource.org/licenses/gpl-license.php GNU Public License
* @name Class Zipper
*/

/**
* @package class_Zipper
* Nom du projet: Class_Zipper.php
* Version du projet: 1.0
* Auteur: Vincent DUFFAUT pour AlloWin
* Copyright: Allowin (http://www.allowin.com)
* Adresse E-Mail: vduffaut at allowin.com
*
* V1.0: 02/07/06 - Premire version
*
* Remarque : ce code est issu d'une remarque trouve sur le site http://www.phpcs.com
* A la suite d'une source de Malik7934 montrant un formulaire d'upload permettant de crer un fichier ZIP  partir de ce fichier envoy,
* un commentaire demandait s'il serait possible de grer un dossier ou une liste de fichiers de faon automatique
*
* Du coup l'ide m'est venue d'crire ce code pour mon besoin propre :
* faire une sauvegarde Zippe avant une mise  jour ou un test comportant des oprations complexes, etc.
*
* Si le fichier Zip  crer n'est pas nomm, un nom automatique lui est affect : 'Sauvegarde JJ/MM/AAAA HhMmSs.zip'

* Cette classe s'appuie sur l'excellente bibliothque pclZip dcouverte par hasard sur le formulaire cit ci-dessus via http://www.phpcs.com.
*
* Le site : http://www.phpconcept.net/phpzip/index.php permet de rcuprer la dernire version (2.5  la rdaction de ces lignes)
* ainsi que la documentation. D'autres sources sont d'ailleurs mises  disposition pour grer d'autres formats de compression...
*
* La classe Zipper a donc pour but de simplifier  l'extrme la cration d'une archive ZIP contenant :
* soit une liste de fichiers
* soit un dossier et tout son contenu.
*
* test sous PHP5, vous devriez pouvoir l'utiliser en PHP4 en modifiant les mots protected par var juste en-dessous de ces lignes d'explication
*
* <code>
* $archive = new Zipper();								// Cration de l'objet
* $archive->DefinitNomDossierAZipper('Galeries');		// Indique quel est le dossier qu'il faut explorer et dont le contenu doit tre 'Zipp'
* if(! $archive->ZipperFichiers()) echo 'ECHEC';		// Affiche un message en cas d'chec
* </code>
*
* Les methodes dcrites permettent d'en modifier le fonctionnement, mais quasiment rien n'est obligatoire
*
* Tous les paramtres disposent de mthodes pour en modifier le contenu
*
* Remarque : si vous indiquez un nom de dossier, n'indiquez pas de liste de fichiers...
*            si vous le faites tout de mme, le dossier sera utilis et la liste de fichiers ignore
*/
class Zipper
{
    /**
	 * Contient le nom du fichier ZIP rsultant (avec chemin d'accs au besoin) si l'extension n'est pas fournie, elle est ajoute
     *
     * @access private
     * @var string
     */
	private $nomZIP = '';

    /**
	 * Faut-il supprimer l'archive si elle existe avant utilisation ? Si elle existe sans suppression demande, le traitement s'interrompt
     *
     * @access private
     * @var bool
     */
	private $SupprimerSiExiste = true;

    /**
	 * Si un nom de dossier est indiqu, tout son contenu sera compress (ET les sous-dossiers)  la place de $fichiers
     *
     * @access private
     * @var string
     */
	private $dossier;

	/**
	 * Tableau des noms des fichiers  Zipper (avec chemin ventuel)
     *
     * @access private
     * @var string
     */
	private $fichiers;

	/**
	 *  Texte  crire dans le fichier joint qui sera cr au vol (un texte auto est crit par dfaut)
     *
     * @access private
     * @var string
     */
	private $contenuALire;

	/**
	 *  Permet d'indiquer si on supprime les fichiers aprs une compression russie
     *
     * @access private
     * @var bool
     */
	private $avecSuppression = false;

	/**
	 * Indique si l'on veut un fonctionnement verbieux (avec messages d'erreur/succs)
     *
     * @access private
     * @var string
     */
	private $avecMessageFin = true;

	/**
	 * Toutes les archives vont dans ce dossier
     *
     * @access private
     * @var bool
     */
	public $dossierArchives = 'archives';
					 
	/**
	 * Nom du fichier contenant le texte associ  toute archive cre
     *
     * @access private
     * @var string
     */
	private $aLire = 'A-Lire.txt';

	/**
	 * Par dfaut la liste des noms des fichiers inclus est insr dans le texte du fichier de type 'A Lire.txt'
     *
     * @access private
     * @var bool
     */
	private $avecListeFichierOuDossier=true;

    /**
     * Utilisation interne
     * @access private
     */
	private $archs;						// Variable interne

    /**
     * Dfinit le nom du fichier ZIP  crer
     *
     * @access public
     * @param string $nomFichier	Nom duchier ZIP  crer
     */
	function DefinitNomFichierZip($nomFichier)
	{
		$this->nomZip = $nomFichier;
	}

    /**
     * Dfinit si le fichier ZIP doit tre effac avant utilisation s'il existe
     *
     * @access public
     * @param boolean $supprimerSiExiste		Efface le fichier si true
     */
	function DefinitSupprimerFichierZip($supprimerSiExiste)
	{
		$this->supprimerSiExiste = $supprimerSiExiste;
	}

    /**
     * Dfinit le nom du dossier dans lequel tous les fichiers seront ajouts  l'archive
     *
     * @access public
     * @param string $nomDossier		Nom du dossier  compresser
     */
	function DefinitNomDossierAZipper($nomDossier)
	{
		$this->dossier = $nomDossier;
	}

    /**
	 * Ajoute un fichier  la liste de ceux  ajouter  l'archive (chemin possible)
     *
     * @access public
     * @param string $nomFichier		Nom du fichier  ajouter  la liste des fichiers  archiver
     */
	function AjouteFichierAZipper($nomFichier)
	{
		$this->fichiers[] = $nomFichier;
	}

    /**
	 * Dfinit le nom du fichier 'A Lire.txt'
     *
     * @access string public
     * @param string $nomALire		Nom du fichier  ajouter  la liste des fichiers  archiver : fichier de pub ou explication. Si aucun nom n'est dfini, le nom 'A Lire.txt' est utilis par dfaut.
     */
	function DefinitNomFichierALire($nomALire)
	{
		$this->aLire = $nomALire;
	}

    /**
	 * Dfinit le contenu du fichier 'A Lire.txt'
     *
     * @access public
     * @param string $contenuALire		Contenu du fichier  ajouter  la liste des fichiers  archiver : explication, rsum ou publicit
     */
	function DefinitContenuFichierALire($contenuALire)
	{
		$this->contenuALire = $contenuALire;
	}

    /**
	 * Dfinit si on crit la liste des fichiers dans le fichier 'A Lire.txt' (ou quivalent)
     *
     * @access public
     * @param boolean $avecListeFichierOuDossier		Faut-il ajouter la liste des fichiers/dossiers archiv au fichier explicatif/rsum/publicitaire
     */
	function DefinitListeFichierAInclure($avecListeFichierOuDossier)
	{
		$this->avecListeFichierOuDossier = $avecListeFichierOuDossier;
	}

    /**
	 * Dfinit si on supprime les fichiers ajouts une fois que l'archive est correctement gnre
     *
     * @access public
     * @param boolean $avecSuppression		Faut-il supprimer les fichiers archivs aprs le traitement ?
     */
	function DefinitSuppresionFichiersZippes($avecSuppression)
	{
		$this->avecSuppression = $avecSuppression;
	}

    /**
	 * Dfinit le nom du dossier dans lequel l'archive sera cre
     *
     * @access public
     * @param string $dossier		Nom du dossier  archiver
     */
	function DefinitNomDossierDesZip($dossier)
	{
		$this->dossierArchives = $dossier;
	}

    /**
	 * Dfinit si on affiche des messages en fonction du rsultat
     *
     * @access public
     * @param boolean $avecMessageFin		Faut-il afficher les messages en fonction du rsultat du traitement ?
     */
	function DefinitInformation($avecMessageFin)
	{
		$this->avecMessageFin = $avecMessageFin;
	}

    /**
	 * Cette fonction cre le fichier ZIP selon les paramtres par dfaut ou ceux indiqus
     *
     * @access public
     * @return true si tout est correct, false si une erreur est survenue
     */
	function ZipperFichiers()
	{

		if(! is_dir($this->dossierArchives))
		{
			mkdir($this->dossierArchives, 0x777); // Tentative de cration...
			if(! is_dir($this->dossierArchives))
			{
				if($this->avecMessageFin)
					echo 'Le dossier des archives : <b>'.$this->dossierArchives.'</b> n\'existe pas sur votre serveur et sa cration a chou... Merci de corriger !';
				return false;
			}
		}

		require_once('pclzip.lib.php');		// plus d'infos sur www.phpconcept.net/pclzip

		if(empty($this->nomZip))
			$this->nomZip = 'Sauvegarde '.date('Y-m-d H\hm\ms\s');

		if(strpos($this->nomZip, '.zip') === FALSE)
			$this->archs = $this->dossierArchives.'/'.$this->nomZip.'.zip';
		else
			$this->archs = $this->dossierArchives.'/'.$this->nomZip;

		if(file_exists($this->archs) && $this->SupprimerSiExiste)
			unset($this->archs);
		if(file_exists($this->archs))
		{
			if($this->avecMessageFin)
				echo 'Le fichier archive  crer existe dj : <b>'.$this->archs.'</b>.';
			return false;
		}
		$archive = new PclZip($this->archs); // archive en cration
		if(isset($this->dossier) && !empty($this->dossier))
		{
			// Lecture du dossier et construction du tableau des noms des fichiers trouvs
			$fichiersTrouves = array();
			// Lecture du dossier

			$handle=@opendir("$this->dossier");
			if($handle >0)
			{
				while ($fichier = @readdir($handle))
				{
					if($fichier!='.' && $fichier!='..') // Dans un dossier, on a toujours (sauf  la racine) les deux rsultats
						$fichiersTrouves[] = $this->dossier.'/'.$fichier;
				}
				@closedir($handle);
			}
			else
			{
				if($this->avecMessageFin)
					echo 'Le dossier indiqu : <b>'.$this->dossier.'</b> n\'existe pas...';
				return false;
			}

			if(0 == count($fichiersTrouves))
			{
				if($this->avecMessageFin)
					echo 'Le dossier indiqu : <b>'.$this->dossier.'</b> ne contient aucun fichier...';
				return false;
			}
			$this->fichiers = $fichiersTrouves;
			unset($fichiersTrouves);
		}
		elseif(0 == count($this->fichiers))
		{
			if($this->avecMessageFin)
				echo 'Le tableau des noms de fichier indiqu ne contient aucun fichier...';
			return false;
		}
		else
		{
			// Vrifions la prsence des lments indiqus dans le tableau
			foreach($this->fichiers as $fichier)
			{
				if(!is_file($fichier) && !is_dir($fichier))
				{
					if($this->avecMessageFin)
						echo 'Le tableau comprend un fichier ou un dossier : <b>'.$fichier.'</b> qui n\'existe pas...';
					return false;
				}
			}
		}
		$listing = implode(',', $this->fichiers);

		if(file_exists($this->aLire)) // Test dans le dossier actif
			unlink($this->aLire);	// On pourrait mettre @ pour cacher les erreurs, mais celles-ci intressent toujours le dveloppeur

		if(! file_exists($this->aLire)) // Si jamais la suppression ne fonctionne pas, on zappe l'criture du contenu et on utilise celui trouv
		{
			$handle = fopen($this->aLire,'w');
			if($handle > 0)
			{
				if(empty($this->contenuALire))
					fwrite($handle,'Ce fichier ZIP a t cr dynamiquement depuis le site '.$_SERVER['HTTP_HOST']);
				else
					fwrite($handle,$this->contenuALire);

				if($this->avecListeFichierOuDossier)
				{
					if(isset($this->dossier) && !empty($this->dossier))
					{
						$listeAEcrire = '
Dossiers inclus : '.$this->dossier;
					}
					elseif(is_array($this->fichiers))
					{
						$listeAEcrire = '
Liste des fichiers ou dossiers inclus :
';
						foreach($this->fichiers as $fichier)
							$listeAEcrire .= '
'.$fichier;
					}
					else
						$listeAEcrire = '';
					fwrite($handle,'
'.$listeAEcrire);
				}

				fclose($handle);
			}
		}
		$v_list = $archive->create($this->aLire.','.$listing); // cration de l'archive avec son contenu: "A Lire.txt" et les fichiers

		if ($v_list == 0)
		{
			echo 'Erreur de compression : <b>'.$archive->errorInfo(TRUE).'</b>';
			return false;
		}
		elseif($this->avecMessageFin)
		{
			if($this->avecSuppression)
			{
				// On ne supprime les fichiers que si l'archive est correctement cre
				unlink($this->aLire);
				foreach($this->fichiers as $fichier)
				{
					if(is_file($fichier))
						unlink($fichier);
					elseif(is_dir($fichier))
					{
						// Supprimer tout le contenu de ce dossier (et mme les sous-dossiers)
						$this->SupprimerDossier($fichier);
					}
				}
			}
			echo '<center><i>Le contenu a t zipp.</i><br><br>';
			echo 'Il est accessible en cliquant sur ce <b><a href="'.$this->archs.'">lien</a> ('.round(filesize($this->archs)/1024).' Ko)</b><br />'; // et on peut vrifier le rsultat
		}
		return true;
	}

    /**
	 * Cette fonction, rcursive, permet de supprimer tout le contenu d'un dossier, fichiers et sous-dossiers
     *
     * @access private
     * @param string $dossier		Nom du dossier  vider et supprimer
     * @return true si tout est correct, false si une erreur est survenue
     */
	function SupprimerDossier($dossier)
	{
		static $handle;

		// Lecture du dossier
		$handle=@opendir("$dossier");
		if($handle >0)
		{
			while ($fichier = @readdir($handle))
			{
				if($fichier!='.' && $fichier!='..') // Dans un dossier, on a toujours (sauf  la racine) des deux rsultats
				{
					if(is_file($dossier.'/'.$fichier))
						unlink($dossier.'/'.$fichier);
					elseif(is_dir($dossier.'/'.$fichier))
					{
						// Supprimer tout le contenu de ce dossier (et mme les sous-dossiers)
						$this->SupprimerDossier($dossier.'/'.$fichier);
					}
				}
			}
			@closedir($handle);
			rmdir($dossier.'/'.$fichier);
			return true;
		}
		else
		{
			if($this->avecMessageFin)
				echo 'Le dossier indiqu : <b>'.$dossier.'</b> n\'existe pas...';
			return false;
		}

	}
}
?>